
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

        Asset( "ANIM", "anim/yuno.zip" ),
        Asset( "ANIM", "anim/ghost_yuno_build.zip" ),
}
local prefabs = {

}

-- Custom starting items
local start_inv = {

}

-- When the character is revived from human
local function onbecamehuman(inst)
	-- Set speed when loading or reviving from ghost (optional)
	inst.components.locomotor.walkspeed = 8
	inst.components.locomotor.runspeed = 8
end

--sanity status
local function antilunatic(inst)

	if inst.components.sanity.current >= (25) and inst.components.sanity.current < (50) then

		inst.components.combat.damagemultiplier = 1.30
		inst.components.health.absorb = 0.30
	   
	   	inst.components.locomotor.walkspeed = ( TUNING.WILSON_WALK_SPEED * 1.3 )
		inst.components.locomotor.runspeed = ( TUNING.WILSON_RUN_SPEED * 1.3 )

		
	elseif inst.components.sanity.current >= (10) and inst.components.sanity.current < (25) then
		
		inst.components.combat.damagemultiplier = 1.50
		inst.components.health.absorb = 0.00
	   
	   	inst.components.locomotor.walkspeed = ( TUNING.WILSON_WALK_SPEED * 1.5 )
		inst.components.locomotor.runspeed = ( TUNING.WILSON_RUN_SPEED * 1.5)
		
		
	elseif inst.components.sanity.current >= (0) and inst.components.sanity.current < (10) then
		
		inst.components.combat.damagemultiplier = 2
		inst.components.health.absorb = 0.00
	   
	   	inst.components.locomotor.walkspeed = ( TUNING.WILSON_WALK_SPEED * 2 )
		inst.components.locomotor.runspeed = ( TUNING.WILSON_RUN_SPEED * 2)
		
		end

end	


--sanity status

-- When loading or spawning the character
local function onload(inst)
    inst:ListenForEvent("ms_respawnedfromghost", onbecamehuman)

    if not inst:HasTag("playerghost") then
        onbecamehuman(inst)
    end
end


-- This initializes for both the server and client. Tags can be added here.
local common_postinit = function(inst) 
	-- Minimap icon
	inst.MiniMapEntity:SetIcon( "yuno.tex" )
end

-- This initializes for the server only. Components are added here.
local master_postinit = function(inst)
	-- choose which sounds this character will play
	inst.soundsname = "wendy"
	
	-- Uncomment if "wathgrithr"(Wigfrid) or "webber" voice is used
    --inst.talker_path_override = "dontstarve_DLC001/characters/"
	
	-- Stats	
	inst.components.health:SetMaxHealth(250)
	inst.components.hunger:SetMax(150)
	inst.components.sanity:SetMax(50)
	inst.components.health:StartRegen(1, 20)
	inst.entity:AddLight()
	
	-- Damage multiplier (optional)
    inst.components.combat.damagemultiplier = 2
	--on kill

	inst:ListenForEvent("entity_death", function(wrld, data) 
		if data.cause == inst.prefab then
			local delta = 2 -- amount
			inst.components.health:DoDelta(delta)
			inst.components.sanity:DoDelta(delta)
			inst.components.hunger:DoDelta(delta)
		end
	end, GetWorld())

--attempt to change

--attempt to change
	
	-- Hunger rate (optional)
	inst.components.hunger.hungerrate = 1 * TUNING.WILSON_HUNGER_RATE
	
	inst.OnLoad = onload
    inst.OnNewSpawn = onload
	inst:ListenForEvent("equip", function()
		inst.AnimState:ClearOverrideSymbol("swap_hat")
		inst.AnimState:Show("hair")
		inst.AnimState:ClearOverrideSymbol("swap_body")
	end)

	inst:ListenForEvent("sanitydelta", function(inst) antilunatic(inst) end ) --this is needed for the sanity perk
		
	antilunatic(inst)
		
	return inst																  --this is needed for the sanity perk
	
end

return MakePlayerCharacter("yuno", prefabs, assets, common_postinit, master_postinit, start_inv)
